#include "mainsock.h"
#include "connection.h"
#include "flags.h"

#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <arpa/inet.h>

MainSock::MainSock() {
}

int MainSock::Create(int port, Global *ppGlobal) {
	// create a 'listener' (note: You CAN have more than one of these
	// I know. It's freaking wierd. Get over it
	// first, create a special type of connection to handle this
	// socket

	pGlobal = ppGlobal;
		// This is very, very tacky

	pConnect = new Connection(ppGlobal);
	
	// second, let's set the main_socket flag

	pConnect->SetFlag(CFLAG_MAIN_SOCKET);
	
	// third, let's create a fd and rock and roll.

	if(pConnect->SetAccept(port))
		return(-1);

	pConnect->SetFlag(CFLAG_ALIVE);

	return(0);
}

Connection *MainSock::Accept() {
	// connect
	Connection *pRet;
	int nfd;

	pRet = new Connection(pGlobal);

	if((nfd = accept(pConnect->GetFd(), (struct sockaddr *)&pRet->in_addr, sizeof(struct sockaddr_in)))) {

		pRet->SetFd(nfd);
	
	} else {
		delete pRet;
		return(NULL);
	}
}

MainSock::~MainSock() {
	// disconnect, unbind, and in general go down in flames
}
