#include "connection.h"
#include "attrib.h"
#include "room.h"
#include "player.h"
#include "parse.h"
#include "global.h"
#include "mainsock.h"
#include "flags.h"
#include <stdio.h>
#include <signal.h>

//Database *db;
//Conf *c;

Global * pGlobal;
Connection * pWork;


int main(int argc, char *argv[]) {
	// main loop
	
	signal(SIGPIPE,SIG_IGN);

	pGlobal = new Global;
	if( -1 == pGlobal->pMainSock->Create(4049,pGlobal)) {
		perror("Error: Couldn't create main socket:");
		exit(-1);
	}

	
	while(pGlobal->pMainSock->pConnect->GetFlag(CFLAG_ALIVE)) {
		if(pGlobal->pMainSock->pConnect->WaitForRead()) {
			// new connection
			pWork = pGlobal->pMainSock->Accept(); 
			if(pWork) {
				// start a new thread
				pWork->StartThread();
			}
		}
	}	

	if(!pGlobal->pMainSock->pConnect->GetFlag(CFLAG_ALIVE)) {
		printf("Talker down\n"); // debugging
	}
}



