#ifndef __GLOBAL_H
#define __GLOBAL_H

#include <stdarg.h>

class Connection; // forward declare

class Global {

	public:
		Global();
		~Global();
		int GetNewConnectId();
		class Connection * GetConnectionHead();
		class Connection * GetConnectionTail();
		int SetConnectionHead(class Connection *);
		int SetConnectionTail(class Connection *);
		int WriteAllPlayers(char *fmt, ...);
		int WriteAllPlayersExcept(Connection *pC, char *fmt, ...);
		
	public: // variables
		class MainSock *pMainSock;
		class Connection * pConnectionHead;
		class Connection * pConnectionTail;
	private:
		int i_ConnectionId;
};


extern class Global * pGlobal;

#endif
